#!/usr//bin/perl
#
#matthias@penthouse.boerde.de

use Getopt::Std;
use File::Basename;
use Term::ReadLine;

  $DJPEG="/usr/bin/djpeg";
  $CJPEG="/usr/bin/cjpeg";

  getopts("hc:t:s:f:d:b:");
  $arg0 = $ARGV[0]; 
  $Title = $opt_t;
  $Cols = $opt_c;
  $Scale = $opt_s;
  $HtmlName = $opt_f;
  $Comment = $opt_b;

  if (defined( $opt_h ))
  {
    printf <<HELP;
Erzeugt fuer eine Liste von jpg's eine index.html und Thumbnails
  -c <Anzahl der Spalten der Bildertabelle>
  -t "Titel"
  -b Text der unter dem Titel erscheinen soll
  -s "Verkleinerung der Thumbnails 2,4,8
  -f index.html
HELP
    exit;
  }


sub Head
{ 
  my($Title, $Comment) = @_;

  my $s=<<"H_HEAD";
  <HTML>
  <HEAD><TITLE>$Title</TITLE></HEAD>
  <BODY>
  <h1 align=center>$Title</h1>
  $Comment 
  <TABLE border=0 rules=none ALIGN=CENTER cellspacing=1 cellpadding=0>
H_HEAD
  return $s;
}

sub Row
{
  my $s=<<"H_ROW";
  <TR>
H_ROW
  return $s;
}

sub Col
{
  my($File, $Filek) = @_;

  my $s=<<"H_COL";
  <TD ALIGN=CENTER VALIGN=CENTER> <A HREF="$File"> <IMG SRC="$Filek" ALT="$File"> </A></TD>
H_COL
  return $s;
}

sub RowE
{
  my $s=<<"H_ROWE";
  </TR>
H_ROWE
  return $s;
}

sub HeadE
{
  my $s=<<"H_HEADE";
  </TABLE>
  </BODY>
  </HTML>
H_HEADE
  return $s;
}

  #print Head("test") . Row . Col("1.jpg","k1.jpg") . RowE . HeadE ;

  my $term = Term::ReadLine->new("Jpidx");

  $Title ||= $term->readline('Titel:');
  $Comment ||= $term->readline('Kommentar:');
  $Cols  ||= $term->readline('Anzahl der Spalten:');
  $Scale ||= $term->readline('Verkleinerungsfaktor (2,4,8):');
  $HtmlName ||= "index.html";
  $Cols  ||= 2;
  $Scale ||= 8;

  open ( OUT,"> $HtmlName" ) or die "Datei $HtmlName konnte nicht angelegt werden.";
  unless (-d 'k/') 
  {
    mkdir 'k', 0755 or die 'Cannot Create x\ Directory!';
  }
  printf OUT Head($Title,$Comment);
  @jpgfiles = <*.jpg>;
  push (@jpgfiles, <*.JPG>); 
  push (@jpgfiles, <*.gif>);
  push (@jpgfiles, <*.GIF>);
  push (@jpgfiles, <*.png>);
  push (@jpgfiles, <*.PNG>);
  $CurCol = 1;
  $Count = 0;
  printf OUT Row;
  foreach $jpg(@jpgfiles)
  { #Erzeuge die kleinen Bilder
    $kjpg = "k/k$jpg"; 
    print "$jpg\n";
    $status = system("$DJPEG -scale 1/$Scale $jpg | $CJPEG > $kjpg ");
    die "Probleme mit djpeg und cjpeg" unless $status == 0;
    printf OUT Col("$jpg","$kjpg");
    $CurCol += 1;
    if ( $CurCol > $Cols )
    {
      printf OUT RowE . Row;
      $CurCol = 1;
    }
    $Count += 1; 
  }
  printf OUT RowE . HeadE;
  
  print "$HtmlName mit $Count Bildern erzeugt.\n";



